<?PHP
	include "include/globals.php";

	if(!isset($_GET["newmailbox"])) {
		if ($_SESSION["currentfolder"] == "") {
			header("Location: error.php?error=" . urlencode("Maillist called with no newmailbox, and there is no current folder to display"));
			exit;
		}
	}

	if ((isset($_GET["offset"]) && ($_GET["offset"] < 0)) || (!isset($_GET["offset"]))){
		$offset = 0;
	} else {
		$offset = (int)$_GET["offset"];
	}

	if (isset($_GET["newmailbox"]) && ($_SESSION["currentfolder"] != $_GET["newmailbox"])) {
		$_SESSION["currentfolder"] = $_GET["newmailbox"];
		$_SESSION["currentmessage"] = -1;
	}

	$mbox = open_mailbox($_SESSION["currentfolder"]);

	// Let's test if we need to alter some stuff.
	if ($_SESSION["currentfolder"] == ($_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"])) {
		$folder = "sent";
	} else {
		$folder = "";
	}

	$mboxinfo = imap_check($mbox);
	$mboxstatus = imap_status($mbox, $_SESSION["currentfolder"],SA_ALL);

	// create the translation table outside of the functions for speed
        $transtable = get_html_translation_table(HTML_ENTITIES);
        $transtable = array_flip($transtable);

	// formats and prints a mail header
	function printFunctions($mbox, $headerinfo, $index) {
		$string = "	A(";

                if ($GLOBALS["folder"] == "sent") {
                        $string .= "'" . strtr(format_address($headerinfo->to), $GLOBALS["transtable"]) . "',";
                } else {
                        if (isset($headerinfo->from)) {
				$string .= "'" . strtr(format_address($headerinfo->from), $GLOBALS["transtable"]) . "',";
			} else {
				$string .= "'No Sender',";
			}
                }
                if(!isset($headerinfo->subject) || ($headerinfo->subject == "")) {
                        $string .= "'" . addslashes(gettext("No Subject")) . "',";
                } else {
                        $subject = strtr($headerinfo->subject, $GLOBALS["transtable"]);
                        $string .= "'" . addslashes(ISDecode($subject)) . "', ";
                }

		if (isset($headerinfo->date) && strtotime($headerinfo->date) != -1) {
			$string .= "fd('" . $headerinfo->date . "'),";
		} else {
			$string .= "'No Date',";
		}
		$string .= $headerinfo->uid . ",";
		if ($headerinfo->seen == 0) {
			$string .= "1,";
		} else {
			$string .= "0,";
		}
		if ($headerinfo->answered == 0) {
			$string .= "0,";
		} else {
			$string .= "1,";
		}
		$string .= $index . ");";
		echo($string . "\n");
	}

	function format_address($address) {
		global $transtable;

		// if it has a part in <> brackets, remove it
		$address = preg_replace("/\<[^\>]*\>/", "", $address);
		// Remove any quotes
		$address = str_replace("\"", "", $address);
		$address = addslashes(ISDecode($address));
		$address = preg_replace("/\s/", " ", $address);

		return htmlspecialchars($address);
	}

	PageHeader(1);
?>
<head>
	<title></title>
	<style type="text/css">
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/maillist.css";
	</style>
	<script type="text/javascript">
		<!--
		<?php
			if ($folder == "sent") {
				echo("parent.maillistheader.location = 'maillistheader.php?sent=1';\n");
			} else {
				echo("parent.maillistheader.location = 'maillistheader.php';\n");
			}
		?>
		var selectedmessages = {};
		var lastrow = '';
		var currentemailrow;
		var timeoutID = '';
		var mttb;

		// Format a date using the local browser's time
		function fd(strDate) {
			objDate = new Date(strDate);
			if (objDate.getHours() >= 12) {
				var hours = objDate.getHours()%12;
				if (hours == 0) {
					hours = 12;
				}
				var ampm = 'PM';
			} else {
				var hours = objDate.getHours();
				if (hours == 0) {
					hours = 12;
				}
				var ampm = 'AM';
			}
			var minutes = objDate.getMinutes();
			if (minutes < 10) {
				minutes = '0' + minutes.toString();
			}
			var year = objDate.getYear();
			if (year < 2000) {
				year = year + 1900;
			}
			return (objDate.getMonth()+1) + '/' + objDate.getDate() + '/' + year + ' ' + hours + ':' + minutes + ' ' + ampm;
		}

		function clearselect() {
			// clear any selections that were made in mozilla
			if(!document.all) {
				sel = window.getSelection();
				if (sel) {
					sel.collapse(document.body, 0);
				}
			}
		}

		function vme(e, fullclick) {
			if (!e) {
				e = window.event;
				row = e.srcElement.parentElement;
				if (e.button != 1) {
					return false;
				}
			} else {
				if (e.which != 1) {
					return false;
				}
				if (e.target.nodeName == 'TD') {
					row = e.target.parentNode;
				} else {
					row = e.target.parentNode.parentNode;
				}
			}

			if(fullclick != true && e.ctrlKey) {
				return true;
			}

			if(fullclick != true && selectedmessages[row.id] == 1) {
				return true;
			}

			if (!row) {
				return false;
			}
			if (row.id.substr(0, 4) != 'mess') {
				if ((row.nodeName != 'TR') && (row.nodeName != 'HTML') && (row.nodeName != 'BODY') && (row.nodeName != 'DIV')){
					alert('Contact info@insidesystems.net and say you saw \'' + row.nodeName + '\'');
				}
				return;
			} else if (e.shiftKey) {
				vm(row, 'shift', true);
			} else if (e.ctrlKey) {
				vm(row, 'ctrl', true);
			} else {
				vm(row, '', true);
			}
		}

		function vm(row, modkey, loadmessage) {
			var i;
			currentemailrow = row;
			var mid = row.id;
			if (timeoutID != '') {
				clearTimeout(timeoutID);
			}

			timeoutID = setTimeout('parent.hiddenframe.location.href=\'hidden.php?action=refreshcurrentfolder\'', <?PHP echo ($_SESSION["readdelay"] * 1000);?>);

			if (lastrow != '') {
				if (modkey == 'shift') {
					if (row.index > lastrow.index) {
						while (currentemailrow != lastrow) {
							currentemailrow.className = 'selectedrow';
							selectedmessages[currentemailrow.id] = 1;
							currentemailrow = currentemailrow.previousSibling;
						}
					} else if (row.index < lastrow.index){
						while (currentemailrow != lastrow) {
							currentemailrow.className = 'selectedrow';
							selectedmessages[currentemailrow.id] = 1;
							currentemailrow = currentemailrow.nextSibling;
						}
					}
				} else if (modkey == 'ctrl') {
					if (selectedmessages[mid] == 1) {
						row.className = 'unselectedrow';
						delete(selectedmessages[mid]);
					} else {
						row.className = 'selectedrow';
						selectedmessages[mid] = 1;
					}
				} else {
					for (var message in selectedmessages) {
						document.getElementById(message).className = 'unselectedrow';
					}
					selectedmessages = new Object();
					selectedmessages[mid] = 1;
					row.className = 'selectedrow';
				}
			} else {
				selectedmessages[mid] = 1;
				row.className = 'selectedrow';
			}

			lastrow = row;
			if (loadmessage == true) {
				parent.mail.document.location.href='mailwrapper.php?newmessage=' + mid.substr(4);
				if (window.event) {
					window.event.cancelBubble = true;
				}
			}
		}

		// returns the folder a drag stopped on or false
		function findtarget(clickx, clicky) {
			folderlinks = parent.folderlist.document.links;
			framewidth = parent.folderlist.document.body.offsetWidth;
			frameheight = parent.folderlist.document.body.offsetHeight;
			clickx = framewidth - (clickx * -1);

			if(clickx > framewidth || clickx < 0) {
				return false;
			}

			if(clicky > frameheight || clicky < 0) {
				return false;
			}

			for(var i = 0; i < folderlinks.length; i++) {
				var tx = folderlinks[i].offsetLeft
				var ty = folderlinks[i].offsetTop
				var bx = folderlinks[i].offsetLeft + folderlinks[i].offsetWidth
				var by = folderlinks[i].offsetTop + folderlinks[i].offsetHeight

				if(clickx > tx && clickx < bx && clicky > ty && clicky < by) {
					return(folderlinks[i]);
				}
			}

			return false;
		}

		function stopdrag(e) {
			clearselect();
			parent.folderlist.dragunderway = 0;
			evt = (e) ? e : event;
			listcell = parent.folderlist.document.getElementById('listcell');
			if(e) {
				var folder = findtarget(evt.clientX, evt.clientY);
			}
			else {
				var folder = findtarget(evt.x, evt.y);
			}
			if(folder != false) {
				// build a form in the hidden frame and submit it
				var doc = parent.hiddenframe.document;
				doc.write('<html>\n<head>\n\t<title>move mail</title>\n</head>\n<body>\n</body>\n</html>');
				doc.close();

				var newform = doc.createElement('form');
				newform.setAttribute("id", "movemailform");
				newform.setAttribute("method", "post");
				newform.setAttribute("action", "movemail.php");
				doc.body.appendChild(newform);

				var elem = doc.createElement('input');
				elem.setAttribute('type', 'hidden');
				elem.setAttribute('id', 'dragmove');
				elem.setAttribute('name', 'dragmove');
				elem.setAttribute('value', 'set');
				newform.appendChild(elem);

				elem = doc.createElement('input');
				elem.setAttribute('type', 'hidden');
				elem.setAttribute('id', 'tofolder');
				elem.setAttribute('name', 'tofolder');
				elem.setAttribute('value', folder.href);
				newform.appendChild(elem);

				elem = doc.createElement('input');
				elem.setAttribute('type', 'hidden');
				elem.setAttribute('id', 'movemailb');
				elem.setAttribute('name', 'movemailb');
				elem.setAttribute('value', 'set');
				newform.appendChild(elem);

				elem = doc.createElement('input');
				elem.setAttribute('type', 'hidden');
				elem.setAttribute('id', 'reloadhiddenframe');
				elem.setAttribute('name', 'reloadhiddenframe');
				elem.setAttribute('value', 'set');
				newform.appendChild(elem);

				for (var message in selectedmessages) {
					elem = document.createElement('input');
					elem.type = 'hidden';
					elem.name = message;
					elem.value = '1';
					newform.appendChild(elem);
				}

				doc.getElementById('movemailform').submit();
			}
			else {
				vme(e, true);
			}

			document.body.style.cursor='default';
			return true;
		}

		function A(from, subject, date, headernum, read, answered, index) {
			var row = document.createElement('TR');
			row.index = index;
			row.id = 'mess' + headernum;
			if (read == 1) {
				row.style.fontWeight = 'bold';
			} else {
				row.style.fontWeight = 'normal';
			}

			// Take care of our answered row
			cell = document.createElement('TD');
			cell.className = 'an';
			if (answered == 1) {
				var img = document.createElement('IMG');
				img.src = '<?php echo("themes/" . $_SESSION['themedir'] . "/answered.gif"); ?>';
				cell.appendChild(img);
			}
			row.appendChild(cell);

			// Take care of our from
			cell = document.createElement('TD');
			cell.className = 'fr';
			cell.appendChild(document.createTextNode(from));
			row.appendChild(cell);

			// Take care of our subject
			cell = document.createElement('TD');
			cell.className = 'su';
			cell.appendChild(document.createTextNode(subject));
			row.appendChild(cell);

			// Take care of our date
			cell = document.createElement('TD');
			cell.appendChild(document.createTextNode(date));
			if (window.event) {
				cell.style.width = '127px';
			} else {
				cell.style.width = '143px';
			}
			row.appendChild(cell);
			mttb.appendChild(row);
		}

		function UP(val) {
			var obj = parent.statusbar.document.getElementById('progressbar');
			if (obj) {
				obj.firstChild.nodeValue = val;
			}
		}

		function TrapKey(e) {
			var modkey = '';
			if (!e) {
				var key = window.event.keyCode;
				if ((window.event.ctrlKey) || (window.event.shiftKey)) {
					modkey = 'ctrl';
				}
			} else {
				var key = e.keyCode;
				if ((e.ctrlKey) || (e.shiftKey)) {
					modkey = 'ctrl';
				}
			}
			if (key == 46) {
				// Delete the selected mail
				parent.hiddenframe.DeleteSelectedMail();
			} else if (key == 40) {
				// Select the next piece of mail
				if (currentemailrow.nextSibling) {
					vm(currentemailrow.nextSibling, modkey, true);
				}
			} else if (key == 38) {
				// Select the previous piece of mail
				if (currentemailrow.previousSibling) {
					vm(currentemailrow.previousSibling, modkey, true);
				}
			}
		}

		function SetStatusBar(str) {
			var obj = parent.statusbar.document.getElementById('folderstatus');
			if (obj) {
				obj.firstChild.nodeValue = str;
			} else {
				setTimeout('SetStatusBar(\'' + str + '\')', 3000);
			}
		}

		document.onmousedown = vme;
		document.onmouseup = stopdrag;
		document.onkeydown = TrapKey;
		// -->
	</script>
</head>
<body onselectstart="return false">
<?php
	if ($mboxinfo->Nmsgs == 0) {
		echo("	<div id=\"emptyfolder\">\n");
		echo("		<span>" . gettext("No messages in currently selected folder") . "</span>\n");
		echo("	</div>\n");
		echo("<script type=\"text/javascript\">\n");
		echo("	SetStatusBar('0 " . addslashes(gettext("messages")) . ", 0 " . addslashes(gettext("unread")) . "');\n");
		echo("</script>\n");
	} else {
		echo("	<table id=\"messagelist\" cellpadding=\"0\" cellspacing=\"0\">\n");
		echo("	<tbody>\n");
		echo("	</tbody>\n");
		echo("	</table>\n");
		echo("<script type=\"text/javascript\">\n");
		echo("	<!--\n");
		echo("	if (document.all) {\n");
		echo("		mttb = document.getElementById('messagelist').childNodes[0];\n");
		echo("	} else {\n");
		echo("		mttb = document.getElementById('messagelist').childNodes[1];\n");
		echo("	}\n");
		echo("	SetStatusBar('" . $mboxstatus->messages . " " . addslashes(gettext("messages")) . ", " . $mboxstatus->unseen . " " . addslashes(gettext("unread")) . "');\n");
		if ($_SESSION["imapserversorting"] == 1) {
			if ($_SESSION["sortdirection"] == "asc") {
				$reverse = 0;
			} else {
				$reverse = 1;
			}
			if ($_SESSION["sortfield"] == "subject") {
				$sortedmail = imap_sort($mbox, SORTSUBJECT, $reverse, SE_UID + SE_NOPREFETCH);
			} else if ($_SESSION["sortfield"] == "from") {
				$sortedmail = imap_sort($mbox, SORTFROM, $reverse, SE_UID + SE_NOPREFETCH);
			} else if ($_SESSION["sortfield"] == "date") {
				$sortedmail = imap_sort($mbox, SORTDATE, $reverse, SE_UID + SE_NOPREFETCH);
			} else {
				echo("Foobed");exit;
			}

			if ($_SESSION["messagesatonce"] > 0) {
				$sortedmail = array_slice($sortedmail, $offset, $_SESSION["messagesatonce"]);
			}
			$headers = imap_fetch_overview($mbox, implode(",", $sortedmail), FT_UID);
			for ($i = 0; $i < count($headers); $i++) {
				$newheaders[$headers[$i]->uid] = $headers[$i];
			}
			unset($headers);
			for ($i = 0; $i < count($newheaders); $i++) {
				// For some reason this breaks mozilla and the messages won't appear. Gotta ditch until we figure it out.
				//if ((($i % 50) == 0) && ($i != $mboxinfo->Nmsgs)){
				//	echo("</SCRIPT>\n");
				//	echo("<SCRIPT TYPE=\"text/javascript\">\n");
				//	echo("	UP(Math.round(((" . $i . ")/nummessages)*100) + '%');\n");
				//}
				printFunctions($mbox, $newheaders[$sortedmail[$i]], $i);
			}
		} else {

			if ($_SESSION["messagesatonce"] == 0) {
				$headers = imap_fetch_overview($mbox, "1:" . $mboxinfo->Nmsgs);
			} else {
				if (($offset + $_SESSION["messagesatonce"]) > $mboxinfo->Nmsgs) {
					$headers = imap_fetch_overview($mbox, ($offset + 1) . ":" . $mboxinfo->Nmsgs);
				} else {
					$headers = imap_fetch_overview($mbox, ($offset + 1) . ":" . (offset + $_SESSION["messagesatonce"]));
				}
			}
			for ($i = 0; $i < count($headers); $i++) {
				echo("//" . $headers[$i] . "\n");
				// For some reason this breaks mozilla and the messages won't appear. Gotta ditch until we figure it out.
				//if ((($i % 50) == 0) && ($i != $mboxinfo->Nmsgs)){
				//	echo("</SCRIPT>\n");
				//	echo("<SCRIPT TYPE=\"text/javascript\">\n");
				//	echo("	UP(Math.round(((" . $i . ")/nummessages)*100) + '%');\n");
				//}
				printFunctions($mbox, $headers[$i], $i);
			}
		}
		// Now add some stuff to the page to navigate through our limits if we need to
		if (($_SESSION["messagesatonce"] > 0) && (($offset + $_SESSION["messagesatonce"]) < $mboxinfo->Nmsgs)) {
			echo("	var obj = document.createElement('div');\n");
			echo("	obj.className = 'nc';\n");
			echo("	var ne = document.createElement('a');\n");
			echo("	ne.style.color = '#0000FF';\n");
			echo("	ne.style.textDecoration = 'none';\n");
			echo("	ne.href = 'maillist.php?offset=" . ($offset + $_SESSION["messagesatonce"]) . "&newmailbox=" . urlencode($_SESSION["currentfolder"]) . "';\n");
			echo("	ne.appendChild(document.createTextNode('" . addslashes(gettext("Next")) . " " . $_SESSION["messagesatonce"] . " " . addslashes(gettext("messages")) . "'));\n");
			echo("	obj.appendChild(ne);\n");
			echo("	document.body.appendChild(obj);\n");
		}
		// Now, if we need to move backwards, let's do so.
		if ($offset > 0) {
			echo("	var obj = document.createElement('div');\n");
			echo("	obj.className = 'nc';\n");
			echo("	var ne = document.createElement('a');\n");
			echo("	ne.style.color = '#0000FF';\n");
			echo("	ne.style.textDecoration = 'none';\n");
			echo("	ne.href = 'maillist.php?offset=" . ($offset - $_SESSION["messagesatonce"]) . "&newmailbox=" . urlencode($_SESSION["currentfolder"]) . "';\n");
			echo("	ne.appendChild(document.createTextNode('" . addslashes(gettext("Previous")) . " " . $_SESSION["messagesatonce"] . " " . addslashes(gettext("messages")) . "'));\n");
			echo("	obj.appendChild(ne);\n");
			echo("	document.body.insertBefore(obj, document.getElementById('messagelist'));\n");
		}
		echo(" // -->\n");
		echo("</script>\n");
	}
?>
<script type="text/javascript">
	<!--
	UP('Done');
	<?php
		if ($mboxinfo->Nmsgs > 0) {
			// Only set the message if we have to
			if ($_SESSION["currentmessage"] == -1) {
				if ($_SESSION["imapserversorting"] == 1) {
					echo("	vm(document.getElementById('mess" . $sortedmail[0] . "'),'', true);\n");
				} else {
					echo("	vm(document.getElementById('mess" . $headers[0]->uid . "'),'', true);\n");
				}
			} else {
				echo("	vm(document.getElementById('mess" . $_SESSION["currentmessage"] . "'),'', false);\n");
			}
		} else {
			echo("	parent.mail.document.location.href='mailwrapper.php?newmessage=-1';\n");
		}
	?>
	// -->
</script>
</body>
<?php
	// Clear errors and close the connection
	imap_errors();
	imap_close($mbox);
?>
</html>
